package org.eclipse.papyrus.qompass.modellibs.core.xtend;

import com.google.common.base.Objects;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.papyrus.C_Cpp.Ptr;
import org.eclipse.papyrus.FCM.DerivedElement;
import org.eclipse.papyrus.qompass.designer.core.EnumService;
import org.eclipse.papyrus.qompass.designer.core.StUtils;
import org.eclipse.papyrus.qompass.designer.core.UMLTool;
import org.eclipse.papyrus.qompass.designer.core.Utils;
import org.eclipse.papyrus.qompass.designer.core.extensions.IXtend;
import org.eclipse.papyrus.qompass.designer.core.sync.InterfaceSync;
import org.eclipse.papyrus.qompass.designer.core.transformations.TransformationContext;
import org.eclipse.papyrus.qompass.designer.core.transformations.TransformationException;
import org.eclipse.papyrus.qompass.designer.vsl.ParseVSL;
import org.eclipse.papyrus.qompass.modellibs.core.xtend.BehaviorUtil;
import org.eclipse.papyrus.qompass.modellibs.core.xtend.CppUtils;
import org.eclipse.papyrus.qompass.modellibs.core.xtend.StateMachineUtil;
import org.eclipse.papyrus.qompass.modellibs.core.xtend.UMLFlattener;
import org.eclipse.papyrus.uml.tools.utils.PackageUtil;
import org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Event;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.PseudostateKind;
import org.eclipse.uml2.uml.Reception;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.ValueSpecification;
import org.eclipse.uml2.uml.Vertex;
import org.eclipse.uml2.uml.util.UMLUtil;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.CollectionExtensions;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

@SuppressWarnings("all")
public class StateMachineGen implements IXtend {
  private org.eclipse.uml2.uml.Class clazz;
  
  private boolean ooPattern = true;
  
  public StateMachine getStateMachine(final org.eclipse.uml2.uml.Class clazz) {
    EList<Behavior> _ownedBehaviors = ((BehavioredClassifier) clazz).getOwnedBehaviors();
    final Function1<Behavior, Boolean> _function = new Function1<Behavior, Boolean>() {
      public Boolean apply(final Behavior it) {
        return Boolean.valueOf((it instanceof StateMachine));
      }
    };
    Iterable<Behavior> _filter = IterableExtensions.<Behavior>filter(_ownedBehaviors, _function);
    for (final Behavior smBehavior : _filter) {
      return ((StateMachine) smBehavior);
    }
    return null;
  }
  
  public CharSequence activate(final org.eclipse.uml2.uml.Class clazz) {
    CharSequence _xblockexpression = null;
    {
      final StateMachine sm = this.getStateMachine(clazz);
      final UMLFlattener flattener = new UMLFlattener();
      flattener.transform(sm);
      _xblockexpression = this.activate(clazz, sm);
    }
    return _xblockexpression;
  }
  
  public CharSequence activate(final org.eclipse.uml2.uml.Class clazz, final StateMachine sm) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("m_currentState = STATE_");
    Region _region = StateMachineUtil.region(sm);
    Pseudostate _initialState = StateMachineUtil.initialState(_region);
    String _name = _initialState.getName();
    _builder.append(_name, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("#ifdef SM_VERBOSE");
    _builder.newLine();
    _builder.append("cout << \"SM ");
    String _name_1 = clazz.getName();
    _builder.append(_name_1, "");
    _builder.append(": in state ");
    Region _region_1 = StateMachineUtil.region(sm);
    Pseudostate _initialState_1 = StateMachineUtil.initialState(_region_1);
    String _name_2 = _initialState_1.getName();
    _builder.append(_name_2, "");
    _builder.append("\" << endl;");
    _builder.newLineIfNotEmpty();
    _builder.append("#endif");
    _builder.newLine();
    _builder.append("for (;;) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("processEvents();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence processEvents(final org.eclipse.uml2.uml.Class clazz) {
    final StateMachine sm = this.getStateMachine(clazz);
    this.clazz = clazz;
    return this.processEventsSM(clazz, sm);
  }
  
  public CharSequence eventInterceptor(final Operation operation) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.newLine();
    CharSequence _eventInterceptorCommon = this.eventInterceptorCommon(operation);
    _builder.append(_eventInterceptorCommon, "");
    _builder.append(" ");
    _builder.newLineIfNotEmpty();
    _builder.append(" \t\t");
    _builder.append("event.portID = portID;");
    _builder.newLine();
    _builder.append("out->writeEvent(event);");
    _builder.newLine();
    _builder.newLine();
    {
      Type _type = operation.getType();
      boolean _notEquals = (!Objects.equal(_type, null));
      if (_notEquals) {
        _builder.append("return ");
      }
    }
    _builder.append("rconn->");
    CharSequence _cppCall = CppUtils.cppCall(operation);
    _builder.append(_cppCall, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  /**
   * OO variant of event interceptor. Adds call event to pool and
   * then calls the original method (handled by LW container)
   */
  public CharSequence eventInterceptorOO(final Operation operation) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _eventInterceptorCommon = this.eventInterceptorCommon(operation);
    _builder.append(_eventInterceptorCommon, "");
    _builder.append(" ");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence eventInterceptorCommon(final Operation operation) {
    StringConcatenation _builder = new StringConcatenation();
    final DerivedElement derivedElement = UMLUtil.<DerivedElement>getStereotypeApplication(operation, DerivedElement.class);
    _builder.newLineIfNotEmpty();
    {
      boolean _and = false;
      boolean _notEquals = (!Objects.equal(derivedElement, null));
      if (!_notEquals) {
        _and = false;
      } else {
        Element _source = derivedElement.getSource();
        _and = (_source instanceof Reception);
      }
      if (_and) {
        Element _source_1 = derivedElement.getSource();
        final Signal signal = ((Reception) _source_1).getSignal();
        _builder.newLineIfNotEmpty();
        _builder.append("// create event with global signal ID");
        _builder.newLine();
        _builder.append("core::ContainerServices::CallEvent_ event;");
        _builder.newLine();
        _builder.append("event.operationID = ");
        String _name = operation.getName();
        String _literal = EnumService.literal(StateMachineUtil.SIGNAL_ENUM, _name);
        _builder.append(_literal, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
        _builder.append("// map signal into value-buffer and copy attributes");
        _builder.newLine();
        _builder.append("::");
        String _qualifiedName = signal.getQualifiedName();
        _builder.append(_qualifiedName, "");
        _builder.append(" * signal = (::");
        String _qualifiedName_1 = signal.getQualifiedName();
        _builder.append(_qualifiedName_1, "");
        _builder.append(" *) &event.params;");
        _builder.newLineIfNotEmpty();
        {
          EList<Property> _ownedAttributes = signal.getOwnedAttributes();
          for(final Property attribute : _ownedAttributes) {
            _builder.append("signal->");
            String _name_1 = attribute.getName();
            _builder.append(_name_1, "");
            _builder.append(" = ");
            String _name_2 = attribute.getName();
            _builder.append(_name_2, "");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          }
        }
        org.eclipse.uml2.uml.Package _rootPackage = PackageUtil.getRootPackage(operation);
        StateMachineUtil.declareDependencyToSignalIDs(_rootPackage);
        _builder.newLineIfNotEmpty();
        UMLTool.declareDependency(TransformationContext.classifier, signal);
        _builder.newLineIfNotEmpty();
      } else {
        _builder.append("// create event with operationID/portID and pass call");
        _builder.newLine();
        _builder.append("core::ContainerServices::CallEvent_ event;");
        _builder.newLine();
        {
          if (this.ooPattern) {
            _builder.append("event.operationID = OP_ID_");
            String _name_3 = operation.getName();
            _builder.append(_name_3, "");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          } else {
            _builder.append("event.operationID = ID_");
            String _name_4 = operation.getName();
            _builder.append(_name_4, "");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  public CharSequence processEventsSM(final BehavioredClassifier clazz, final StateMachine sm) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// processEvents body - generated by Qompass ");
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    _builder.append("// supports ports ");
    {
      EList<Port> _ownedPorts = ((org.eclipse.uml2.uml.Class) clazz).getOwnedPorts();
      for(final Port port : _ownedPorts) {
        _builder.append(" ");
        String _name = clazz.getName();
        String _plus = ("PortEnum_" + _name);
        String _name_1 = clazz.getName();
        String _plus_1 = ("port_" + _name_1);
        String _plus_2 = (_plus_1 + "_");
        String _name_2 = port.getName();
        String _plus_3 = (_plus_2 + _name_2);
        String _literal = EnumService.literal(_plus, _plus_3);
        _builder.append(_literal, "");
      }
    }
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("core::ContainerServices::CallEvent_ event;");
    _builder.newLine();
    _builder.append("int timeout;");
    _builder.newLine();
    _builder.append("int newState;");
    _builder.newLine();
    _builder.append("bool needsTrigger;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("switch(m_currentState) {");
    _builder.newLine();
    {
      Region _region = StateMachineUtil.region(sm);
      EList<Vertex> _subvertices = _region.getSubvertices();
      for(final Vertex state : _subvertices) {
        _builder.append("\t");
        _builder.append("case ");
        String _name_3 = clazz.getName();
        String _plus_4 = ("LStateIDs_" + _name_3);
        String _name_4 = state.getName();
        String _plus_5 = ("STATE_" + _name_4);
        String _literal_1 = EnumService.literal(_plus_4, _plus_5);
        _builder.append(_literal_1, "\t");
        _builder.append(":");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("\t");
        _builder.append("// -------- treatment of accepted events");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("\t");
        CharSequence _acceptableEvents = this.acceptableEvents(state);
        _builder.append(_acceptableEvents, "\t\t");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("\t");
        _builder.append("break;");
        _builder.newLine();
      }
    }
    _builder.append("\t");
    _builder.append("default:");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("OSAL_ERROR (\"Inconsistent state\");");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("break;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.append("if (animOut != 0) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("animOut->enterState(newState, ");
    String _fragment = UMLTool.fragment(clazz);
    _builder.append(_fragment, "\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  /**
   * Pass the actual to which the port is bound. In case of a CallEvent, pass the implemented interface
   * (Not the class to which the state machine is bound). This is useful in the context of components
   * whose ports implement an interface
   */
  public CharSequence cetrigger(final Operation operation) {
    CharSequence _xblockexpression = null;
    {
      final Interface intf = UMLTool.implementsInterface(operation);
      CharSequence _xifexpression = null;
      boolean _notEquals = (!Objects.equal(intf, null));
      if (_notEquals) {
        CharSequence _xblockexpression_1 = null;
        {
          final org.eclipse.uml2.uml.Package packageRef = StateMachineUtil.boundPackageRef(intf);
          StateMachineUtil.declareDependencyToOperationIDs(packageRef);
          StringConcatenation _builder = new StringConcatenation();
          String _qualifiedName = packageRef.getQualifiedName();
          _builder.append(_qualifiedName, "");
          _builder.append("::ID_");
          String _name = operation.getName();
          _builder.append(_name, "");
          _xblockexpression_1 = _builder;
        }
        _xifexpression = _xblockexpression_1;
      } else {
        StringConcatenation _builder = new StringConcatenation();
        _builder.append("OP_ID_");
        String _name = operation.getName();
        _builder.append(_name, "");
        _xifexpression = EnumService.literal("LOperationIDs", _builder.toString());
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  public String setrigger(final Trigger trigger) {
    String _xblockexpression = null;
    {
      Event _event = trigger.getEvent();
      final SignalEvent se = ((SignalEvent) _event);
      Signal _signal = se.getSignal();
      String _name = _signal.getName();
      String _plus = (InterfaceSync.SIG_PREFIX + _name);
      _xblockexpression = EnumService.literal(StateMachineUtil.SIGNAL_ENUM, _plus);
    }
    return _xblockexpression;
  }
  
  /**
   * create code for acceptable events
   * 
   * big restriction: will only analyse first of possibly multiple triggers
   */
  public CharSequence acceptableEvents(final Vertex state) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\t");
    _builder.append("// loop on state");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("// execute action ...");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("timeout = -1;\t// no timeout by default");
    _builder.newLine();
    {
      EList<Transition> _outgoings = state.getOutgoings();
      for(final Transition transition : _outgoings) {
        {
          EList<Trigger> _triggers = transition.getTriggers();
          int _size = _triggers.size();
          boolean _greaterThan = (_size > 0);
          if (_greaterThan) {
            _builder.append("\t");
            EList<Trigger> _triggers_1 = transition.getTriggers();
            final Trigger trigger = _triggers_1.get(0);
            _builder.newLineIfNotEmpty();
            {
              Event _event = trigger.getEvent();
              if ((_event instanceof TimeEvent)) {
                _builder.append("\t");
                Event _event_1 = trigger.getEvent();
                final TimeEvent timeEvent = ((TimeEvent) _event_1);
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("// transition ");
                String _name = transition.getName();
                _builder.append(_name, "\t");
                _builder.append(" - trigger: TimeEvent, expression ");
                TimeExpression _when = timeEvent.getWhen();
                ValueSpecification _expr = _when.getExpr();
                EList<String> _bodies = ((OpaqueExpression) _expr).getBodies();
                String _get = _bodies.get(0);
                _builder.append(_get, "\t");
                _builder.append(".");
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("timeout = ");
                TimeExpression _when_1 = timeEvent.getWhen();
                ValueSpecification _expr_1 = _when_1.getExpr();
                EList<String> _bodies_1 = ((OpaqueExpression) _expr_1).getBodies();
                String _get_1 = _bodies_1.get(0);
                long _durationFromVSL = ParseVSL.getDurationFromVSL(_get_1);
                _builder.append(_durationFromVSL, "\t");
                _builder.append("/1000;");
                _builder.newLineIfNotEmpty();
              }
            }
          }
        }
      }
    }
    _builder.newLine();
    {
      boolean _and = false;
      if (!(state instanceof State)) {
        _and = false;
      } else {
        Behavior _entry = ((State) state).getEntry();
        boolean _notEquals = (!Objects.equal(_entry, null));
        _and = _notEquals;
      }
      if (_and) {
        _builder.append("\t");
        _builder.append("// execute entry action");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("executor->");
        Behavior _entry_1 = ((State) state).getEntry();
        String _name_1 = _entry_1.getName();
        _builder.append(_name_1, "\t");
        _builder.append("();");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append("\t");
    _builder.append("needsTrigger = true;");
    _builder.newLine();
    _builder.newLine();
    {
      boolean _hasTransitionWithoutTrigger = this.hasTransitionWithoutTrigger(state);
      if (_hasTransitionWithoutTrigger) {
        {
          EList<Transition> _outgoings_1 = state.getOutgoings();
          for(final Transition transition_1 : _outgoings_1) {
            {
              EList<Trigger> _triggers_2 = transition_1.getTriggers();
              int _size_1 = _triggers_2.size();
              boolean _equals = (_size_1 == 0);
              if (_equals) {
                {
                  Constraint _guard = transition_1.getGuard();
                  boolean _notEquals_1 = (!Objects.equal(_guard, null));
                  if (_notEquals_1) {
                    _builder.append("\t");
                    Constraint _guard_1 = transition_1.getGuard();
                    ValueSpecification _specification = _guard_1.getSpecification();
                    this.createGuardFct(_specification, null);
                    _builder.newLineIfNotEmpty();
                    _builder.append("\t");
                    _builder.append("if (executor->");
                    Constraint _guard_2 = transition_1.getGuard();
                    ValueSpecification _specification_1 = _guard_2.getSpecification();
                    String _name_2 = _specification_1.getName();
                    _builder.append(_name_2, "\t");
                    _builder.append("()) {");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("newState = STATE_");
                Vertex _target = transition_1.getTarget();
                String _name_3 = _target.getName();
                _builder.append(_name_3, "\t");
                _builder.append(";");
                _builder.newLineIfNotEmpty();
                _builder.append("#ifdef SM_VERBOSE");
                _builder.newLine();
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("cout << \"SM ");
                String _name_4 = this.clazz.getName();
                _builder.append(_name_4, "\t\t");
                _builder.append(": transition to state ");
                Vertex _target_1 = transition_1.getTarget();
                String _name_5 = _target_1.getName();
                _builder.append(_name_5, "\t\t");
                _builder.append("\" << endl;");
                _builder.newLineIfNotEmpty();
                _builder.append("#endif");
                _builder.newLine();
                {
                  Behavior _effect = transition_1.getEffect();
                  boolean _notEquals_2 = (!Objects.equal(_effect, null));
                  if (_notEquals_2) {
                    _builder.append("\t");
                    _builder.append("executor->");
                    String _effectName = this.effectName(transition_1);
                    _builder.append(_effectName, "\t");
                    _builder.append("();");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("needsTrigger = false;");
                _builder.newLine();
                {
                  Constraint _guard_3 = transition_1.getGuard();
                  boolean _notEquals_3 = (!Objects.equal(_guard_3, null));
                  if (_notEquals_3) {
                    _builder.append("\t");
                    _builder.append("}");
                    _builder.newLine();
                  }
                }
              }
            }
          }
        }
      }
    }
    _builder.newLine();
    _builder.append("\t");
    _builder.append("if (needsTrigger) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("// get an event from the pool.");
    _builder.newLine();
    {
      if (this.ooPattern) {
        _builder.append("\t\t");
        _builder.append("event = eventPool.readEvent(timeout);");
        _builder.newLine();
      } else {
        _builder.append("\t\t");
        _builder.append("event = ep->readEvent(timeout);");
        _builder.newLine();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("else {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("event.operationID = -1;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    final EList<Transition> allOutgoings = state.getOutgoings();
    _builder.newLineIfNotEmpty();
    {
      for(final Transition transition_2 : allOutgoings) {
        {
          EList<Trigger> _triggers_3 = transition_2.getTriggers();
          int _size_2 = _triggers_3.size();
          boolean _greaterThan_1 = (_size_2 > 0);
          if (_greaterThan_1) {
            _builder.append("\t");
            _builder.append("// has ");
            EList<Trigger> _triggers_4 = transition_2.getTriggers();
            int _size_3 = _triggers_4.size();
            _builder.append(_size_3, "\t");
            _builder.append(" outgoing transitions");
            _builder.newLineIfNotEmpty();
            _builder.append("\t");
            EList<Trigger> _triggers_5 = transition_2.getTriggers();
            final Trigger trigger_1 = _triggers_5.get(0);
            _builder.newLineIfNotEmpty();
            {
              Event _event_2 = trigger_1.getEvent();
              if ((_event_2 instanceof TimeEvent)) {
                _builder.append("\t");
                _builder.append("// transition ");
                String _name_6 = transition_2.getName();
                _builder.append(_name_6, "\t");
                _builder.append(" - trigger: TimeEvent (there should be at most one outgoing timed transition per state).");
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("if (event.operationID == core::ContainerServices::EventPool::ID_TIMEOUT) {");
                _builder.newLine();
                {
                  Constraint _guard_4 = transition_2.getGuard();
                  boolean _notEquals_4 = (!Objects.equal(_guard_4, null));
                  if (_notEquals_4) {
                    _builder.append("\t");
                    _builder.append("\t");
                    Constraint _guard_5 = transition_2.getGuard();
                    ValueSpecification _specification_2 = _guard_5.getSpecification();
                    this.createGuardFct(_specification_2, null);
                    _builder.newLineIfNotEmpty();
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("if (executor->");
                    Constraint _guard_6 = transition_2.getGuard();
                    ValueSpecification _specification_3 = _guard_6.getSpecification();
                    String _name_7 = _specification_3.getName();
                    _builder.append(_name_7, "\t\t");
                    _builder.append("()) {");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("newState = STATE_");
                Vertex _target_2 = transition_2.getTarget();
                String _name_8 = _target_2.getName();
                _builder.append(_name_8, "\t\t");
                _builder.append(";");
                _builder.newLineIfNotEmpty();
                _builder.append("#ifdef SM_VERBOSE");
                _builder.newLine();
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("cout << \"SM ");
                String _name_9 = this.clazz.getName();
                _builder.append(_name_9, "\t\t");
                _builder.append(": transition to state ");
                Vertex _target_3 = transition_2.getTarget();
                String _name_10 = _target_3.getName();
                _builder.append(_name_10, "\t\t");
                _builder.append("\" << endl;");
                _builder.newLineIfNotEmpty();
                _builder.append("#endif");
                _builder.newLine();
                {
                  Behavior _effect_1 = transition_2.getEffect();
                  boolean _notEquals_5 = (!Objects.equal(_effect_1, null));
                  if (_notEquals_5) {
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("executor->");
                    String _effectName_1 = this.effectName(transition_2);
                    _builder.append(_effectName_1, "\t\t");
                    _builder.append("();");
                    _builder.newLineIfNotEmpty();
                  }
                }
                {
                  Constraint _guard_7 = transition_2.getGuard();
                  boolean _notEquals_6 = (!Objects.equal(_guard_7, null));
                  if (_notEquals_6) {
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("}");
                    _builder.newLine();
                  }
                }
                _builder.append("\t");
                _builder.append("}");
                _builder.newLine();
              }
            }
            {
              Event _event_3 = trigger_1.getEvent();
              if ((_event_3 instanceof CallEvent)) {
                _builder.append("\t");
                _builder.append("// transition ");
                String _name_11 = trigger_1.getName();
                _builder.append(_name_11, "\t");
                _builder.append(" - trigger: CallEvent (");
                Event _event_4 = trigger_1.getEvent();
                String _name_12 = _event_4.getName();
                _builder.append(_name_12, "\t");
                _builder.append("), operation ");
                Event _event_5 = trigger_1.getEvent();
                Operation _operation = ((CallEvent) _event_5).getOperation();
                String _name_13 = _operation.getName();
                _builder.append(_name_13, "\t");
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("if (event.operationID == ");
                Event _event_6 = trigger_1.getEvent();
                Operation _operation_1 = ((CallEvent) _event_6).getOperation();
                CharSequence _cetrigger = this.cetrigger(_operation_1);
                _builder.append(_cetrigger, "\t");
                _builder.append(") {");
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("newState = STATE_");
                Vertex _target_4 = transition_2.getTarget();
                String _name_14 = _target_4.getName();
                _builder.append(_name_14, "\t\t");
                _builder.append(";");
                _builder.newLineIfNotEmpty();
                _builder.append("#ifdef SM_VERBOSE");
                _builder.newLine();
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("cout << \"SM ");
                String _name_15 = this.clazz.getName();
                _builder.append(_name_15, "\t\t");
                _builder.append(": transition to state ");
                Vertex _target_5 = transition_2.getTarget();
                String _name_16 = _target_5.getName();
                _builder.append(_name_16, "\t\t");
                _builder.append("\" << endl;");
                _builder.newLineIfNotEmpty();
                _builder.append("#endif");
                _builder.newLine();
                {
                  Behavior _effect_2 = transition_2.getEffect();
                  boolean _notEquals_7 = (!Objects.equal(_effect_2, null));
                  if (_notEquals_7) {
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("executor->");
                    String _effectName_2 = this.effectName(transition_2);
                    _builder.append(_effectName_2, "\t\t");
                    _builder.append("();");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("} ");
                _builder.newLine();
              }
            }
            {
              Event _event_7 = trigger_1.getEvent();
              if ((_event_7 instanceof SignalEvent)) {
                _builder.append("\t");
                Event _event_8 = trigger_1.getEvent();
                final SignalEvent signalEvent = ((SignalEvent) _event_8);
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("// transition ");
                String _name_17 = trigger_1.getName();
                _builder.append(_name_17, "\t");
                _builder.append(" - trigger: SignalEvent (");
                String _name_18 = signalEvent.getName();
                _builder.append(_name_18, "\t");
                _builder.append("), signal ");
                Signal _signal = signalEvent.getSignal();
                String _name_19 = _signal.getName();
                _builder.append(_name_19, "\t");
                _builder.newLineIfNotEmpty();
                _builder.append("\t");
                _builder.append("if (event.operationID == ");
                String _setrigger = this.setrigger(trigger_1);
                _builder.append(_setrigger, "\t");
                _builder.append(") {");
                _builder.newLineIfNotEmpty();
                {
                  boolean _or = false;
                  Behavior _effect_3 = transition_2.getEffect();
                  boolean _notEquals_8 = (!Objects.equal(_effect_3, null));
                  if (_notEquals_8) {
                    _or = true;
                  } else {
                    Constraint _guard_8 = transition_2.getGuard();
                    boolean _notEquals_9 = (!Objects.equal(_guard_8, null));
                    _or = _notEquals_9;
                  }
                  if (_or) {
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("// map signal to parameter section");
                    _builder.newLine();
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("::");
                    Signal _signal_1 = signalEvent.getSignal();
                    String _qualifiedName = _signal_1.getQualifiedName();
                    _builder.append(_qualifiedName, "\t\t");
                    _builder.append(" * signal = (::");
                    Signal _signal_2 = signalEvent.getSignal();
                    String _qualifiedName_1 = _signal_2.getQualifiedName();
                    _builder.append(_qualifiedName_1, "\t\t");
                    _builder.append(" *) &event.params;");
                    _builder.newLineIfNotEmpty();
                  }
                }
                {
                  Constraint _guard_9 = transition_2.getGuard();
                  boolean _notEquals_10 = (!Objects.equal(_guard_9, null));
                  if (_notEquals_10) {
                    _builder.append("\t");
                    _builder.append("\t");
                    Constraint _guard_10 = transition_2.getGuard();
                    ValueSpecification _specification_4 = _guard_10.getSpecification();
                    this.createGuardFct(_specification_4, signalEvent);
                    _builder.newLineIfNotEmpty();
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("if (executor->");
                    Constraint _guard_11 = transition_2.getGuard();
                    ValueSpecification _specification_5 = _guard_11.getSpecification();
                    String _name_20 = _specification_5.getName();
                    _builder.append(_name_20, "\t\t");
                    _builder.append("(signal)) {");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("newState = STATE_");
                Vertex _target_6 = transition_2.getTarget();
                String _name_21 = _target_6.getName();
                _builder.append(_name_21, "\t\t");
                _builder.append(";");
                _builder.newLineIfNotEmpty();
                _builder.append("#ifdef SM_VERBOSE");
                _builder.newLine();
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("cout << \"SM ");
                String _name_22 = this.clazz.getName();
                _builder.append(_name_22, "\t\t");
                _builder.append(": transition to state ");
                Vertex _target_7 = transition_2.getTarget();
                String _name_23 = _target_7.getName();
                _builder.append(_name_23, "\t\t");
                _builder.append(" (due to signal ");
                Signal _signal_3 = signalEvent.getSignal();
                String _name_24 = _signal_3.getName();
                _builder.append(_name_24, "\t\t");
                _builder.append(")\" << endl;");
                _builder.newLineIfNotEmpty();
                _builder.append("#endif");
                _builder.newLine();
                {
                  Behavior _effect_4 = transition_2.getEffect();
                  boolean _notEquals_11 = (!Objects.equal(_effect_4, null));
                  if (_notEquals_11) {
                    _builder.append("\t");
                    _builder.append("\t");
                    Behavior _effect_5 = transition_2.getEffect();
                    Signal _signal_4 = signalEvent.getSignal();
                    this.addSignalParameter(_effect_5, _signal_4);
                    _builder.newLineIfNotEmpty();
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("executor->");
                    String _effectName_3 = this.effectName(transition_2);
                    _builder.append(_effectName_3, "\t\t");
                    _builder.append("(");
                    {
                      Signal _signal_5 = signalEvent.getSignal();
                      EList<Property> _attributes = _signal_5.getAttributes();
                      int _size_4 = _attributes.size();
                      boolean _greaterThan_2 = (_size_4 > 0);
                      if (_greaterThan_2) {
                        _builder.append("signal");
                      }
                    }
                    _builder.append(");");
                    _builder.newLineIfNotEmpty();
                  }
                }
                _builder.append("\t");
                _builder.append("\t");
                _builder.append("// ok = EvQUEUE ;");
                _builder.newLine();
                {
                  Constraint _guard_12 = transition_2.getGuard();
                  boolean _notEquals_12 = (!Objects.equal(_guard_12, null));
                  if (_notEquals_12) {
                    _builder.append("\t");
                    _builder.append("\t");
                    _builder.append("}");
                    _builder.newLine();
                  }
                }
                _builder.append("\t");
                _builder.append("}");
                _builder.newLine();
              }
            }
          }
        }
      }
    }
    _builder.newLine();
    _builder.append("\t");
    _builder.append("if (newState != m_currentState) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("m_currentState = newState;");
    _builder.newLine();
    {
      boolean _and_1 = false;
      if (!(state instanceof State)) {
        _and_1 = false;
      } else {
        Behavior _exit = ((State) state).getExit();
        boolean _notEquals_13 = (!Objects.equal(_exit, null));
        _and_1 = _notEquals_13;
      }
      if (_and_1) {
        _builder.append("\t\t");
        _builder.append("// execute exit action");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("executor->");
        Behavior _exit_1 = ((State) state).getExit();
        String _name_25 = _exit_1.getName();
        _builder.append(_name_25, "\t\t");
        _builder.append("();");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append("\t\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public boolean hasTransitionWithoutTrigger(final Vertex state) {
    EList<Transition> _outgoings = state.getOutgoings();
    for (final Transition transition : _outgoings) {
      EList<Trigger> _triggers = transition.getTriggers();
      int _size = _triggers.size();
      boolean _equals = (_size == 0);
      if (_equals) {
        return true;
      }
    }
    return false;
  }
  
  public EList<Transition> calculateTransitions(final Vertex state) {
    final BasicEList<Transition> allOutgoings = new BasicEList<Transition>();
    EList<Transition> _outgoings = state.getOutgoings();
    allOutgoings.addAll(_outgoings);
    EList<Transition> _outgoings_1 = state.getOutgoings();
    for (final Transition transition : _outgoings_1) {
      Vertex _target = transition.getTarget();
      if ((_target instanceof Pseudostate)) {
        Vertex _target_1 = transition.getTarget();
        final Pseudostate ps = ((Pseudostate) _target_1);
        PseudostateKind _kind = ps.getKind();
        boolean _equals = Objects.equal(_kind, PseudostateKind.JUNCTION_LITERAL);
        if (_equals) {
          EList<Transition> _outgoings_2 = ps.getOutgoings();
          Transition[] _clone = ((Transition[])Conversions.unwrapArray(_outgoings_2, Transition.class)).clone();
          CollectionExtensions.<Transition>addAll(allOutgoings, _clone);
        }
      }
    }
    return allOutgoings;
  }
  
  /**
   * Effects are moved from behaviors embedded into transitions towards behaviors of the class. Calculate the name of these
   * effects. The class FilterStateMachines moves the effects (TODO: single name calculation)
   */
  public String effectName(final Transition transition) {
    try {
      String _xblockexpression = null;
      {
        Behavior _effect = transition.getEffect();
        String _name = _effect.getName();
        boolean _equals = Objects.equal(_name, null);
        if (_equals) {
          StateMachine _containingStateMachine = transition.containingStateMachine();
          String _name_1 = _containingStateMachine.getName();
          String _format = String.format("effect of transition has no name (in SM %s)", _name_1);
          throw new TransformationException(_format);
        }
        Behavior _effect_1 = transition.getEffect();
        _xblockexpression = _effect_1.getName();
      }
      return _xblockexpression;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public void addSignalParameter(final Behavior behavior, final Signal signal) {
    EList<Parameter> _ownedParameters = behavior.getOwnedParameters();
    int _size = _ownedParameters.size();
    boolean _equals = (_size == 0);
    if (_equals) {
      final Parameter parameter = behavior.createOwnedParameter("signal", signal);
      StereotypeUtil.apply(parameter, Ptr.class);
    }
  }
  
  public void moveBehavior(final String newName, final org.eclipse.uml2.uml.Class tmClass, final Behavior effect) {
    final Behavior copiedEffect = EcoreUtil.<Behavior>copy(effect);
    Operation _ownedOperation = tmClass.getOwnedOperation(newName, null, null);
    boolean _notEquals = (!Objects.equal(_ownedOperation, null));
    if (_notEquals) {
      return;
    }
    final Operation operation = tmClass.createOwnedOperation(newName, null, null);
    EList<Parameter> _ownedParameters = effect.getOwnedParameters();
    for (final Parameter parameter : _ownedParameters) {
      {
        final Parameter newParameter = EcoreUtil.<Parameter>copy(parameter);
        EList<Parameter> _ownedParameters_1 = operation.getOwnedParameters();
        _ownedParameters_1.add(newParameter);
        StUtils.copyStereotypes(parameter, newParameter);
      }
    }
    copiedEffect.setSpecification(operation);
    copiedEffect.setName(newName);
    EList<Behavior> _ownedBehaviors = tmClass.getOwnedBehaviors();
    _ownedBehaviors.add(copiedEffect);
  }
  
  private final static String CLIB_BOOL = "AnsiCLibrary::bool";
  
  public void createGuardFct(final ValueSpecification specification, final SignalEvent event) {
    final String name = specification.getName();
    Behavior _ownedBehavior = this.clazz.getOwnedBehavior(name);
    boolean _notEquals = (!Objects.equal(_ownedBehavior, null));
    if (_notEquals) {
      return;
    }
    NamedElement booleanNamedElement = Utils.getQualifiedElement(TransformationContext.sourceRoot, StateMachineGen.CLIB_BOOL);
    if ((booleanNamedElement instanceof Type)) {
      Type _copy = TransformationContext.copier.<Type>getCopy(((Type)booleanNamedElement));
      final Type booleanType = ((Type) _copy);
      final Operation operation = BehaviorUtil.createOperation(this.clazz, name, ((Type) booleanType));
      boolean _notEquals_1 = (!Objects.equal(event, null));
      if (_notEquals_1) {
        Signal _signal = event.getSignal();
        final Parameter sigParam = operation.createOwnedParameter("signal", _signal);
        StereotypeUtil.apply(sigParam, Ptr.class);
      }
      final OpaqueBehavior ob = BehaviorUtil.createOpaqueBehavior(this.clazz, operation);
      if ((specification instanceof OpaqueExpression)) {
        EList<String> _languages = ob.getLanguages();
        EList<String> _languages_1 = ((OpaqueExpression)specification).getLanguages();
        _languages.addAll(_languages_1);
        EList<String> _bodies = ((OpaqueExpression)specification).getBodies();
        for (final String body : _bodies) {
          EList<String> _bodies_1 = ob.getBodies();
          _bodies_1.add((("return " + body) + ";"));
        }
      }
    } else {
      System.out.println("was");
    }
  }
}
