/*****************************************************************************
 * Copyright (c) 2015 CEA LIST and others.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   CEA LIST - Initial API and implementation
 *   
 *****************************************************************************/
package org.eclipse.papyrus.umlrt.custom;

/**
 * Declaration of all constants for UML-RT Element Types.
 */
public interface IUMLRTElementTypes {

	public static final String PROTOCOL_CONTAINER_ID = "org.eclipse.papyrus.umlrt.ProtocolContainer"; //$NON-NLS-1$

	public static final String PROTOCOL_ID = "org.eclipse.papyrus.umlrt.Protocol"; //$NON-NLS-1$

	public static final String RT_MESSAGE_SET_ID = "org.eclipse.papyrus.umlrt.RTMessageSet"; //$NON-NLS-1$

	public static final String CAPSULE_ID = "org.eclipse.papyrus.umlrt.Capsule"; //$NON-NLS-1$

	public static final String CAPSULE_PART_ID = "org.eclipse.papyrus.umlrt.CapsulePart";//$NON-NLS-1$

	public static final String RT_PORT_ID = "org.eclipse.papyrus.umlrt.RTPort";//$NON-NLS-1$
	
	public static final String RT_CONNECTOR_ID = "org.eclipse.papyrus.umlrt.RTConnector";//$NON-NLS-1$
	
	public static final String RT_EXCLUDED_ELEMENT_ID = "org.eclipse.papyrus.umlrt.RTRExcludedElement";//$NON-NLS-1$

	public static final String PROTOCOL_MESSAGE_ID = "org.eclipse.papyrus.umlrt.ProtocolMessage";//$NON-NLS-1$
	
	public static final String PROTOCOL_MESSAGE_IN_ID = "org.eclipse.papyrus.umlrt.ProtocolMessageIn";//$NON-NLS-1$
	
	public static final String PROTOCOL_MESSAGE_OUT_ID = "org.eclipse.papyrus.umlrt.ProtocolMessageOut";//$NON-NLS-1$
	
	public static final String PROTOCOL_MESSAGE_INOUT_ID = "org.eclipse.papyrus.umlrt.ProtocolMessageInOut";//$NON-NLS-1$
}
